#pragma once

#include <string>
#include <string.h>

//**************************************************************************************
//
//
//  See the timer_tick function at the end of this file for where all the action happens
//
//**********************************************************************************

namespace SimpleScope {

	using namespace System;
	using namespace System::ComponentModel;
	using namespace System::Collections;
	using namespace System::Windows::Forms;
	using namespace System::Data;
	using namespace System::Drawing;
	using namespace	ZedGraph;
	using namespace std;

	/// <summary>
	/// Summary for Form1
	///
	/// WARNING: If you change the name of this class, you will need to change the
	///          'Resource File Name' property for the managed resource compiler tool
	///          associated with all .resx files this class depends on.  Otherwise,
	///          the designers will not be able to interact properly with localized
	///          resources associated with this form.
	/// </summary>
	public ref class Form1 : public System::Windows::Forms::Form
	{
	public:
		Form1(void)
		{
			InitializeComponent();
			//
			//TODO: Add the constructor code here
			//
		}
	private:

//***********************************************************************
//                                APPLICATION CODE
//************************************************************************
#define num_points      1000


static double 	a_vert = 1, b_vert = 1, horz = 0.001;
static	double	sig_gen_volts = 1.0, sig_gen_freq = 1000.0;
static	int	channel = 1;
static	int 	trig_channel = 0;
static	double	trig_volts = 0.0;
static	int	single_acquire = false;
static	int	auto_acquire = false;
//static	double a_waveform[max_samples], b_waveform[max_samples];

static	int	waiting_for_trigger;	//0 means we have not started an acquire. 1 means we are waiting for the trigger
static	unsigned short	trigger_action;	//for how to capture, 0 = auto, 1 = triggered, 3 = stop
	private: System::Windows::Forms::PictureBox^  pictureBox1;
	private: System::Windows::Forms::Label^  label14;
	private: System::Windows::Forms::Label^  label13;
	private: System::Windows::Forms::Label^  label12;
	private: System::Windows::Forms::Label^  label11;
	private: System::Windows::Forms::Label^  label10;
	private: System::Windows::Forms::Label^  label9;
	private: System::Windows::Forms::Label^  label8;


static	int	vals_changed;


//****************************************************************************

void Setval(System::Windows::Forms::Label^  ctrl, double value, char *suffix)
{
	  char  st[20] = "";
	  strcat_s(st, eng(value, 3, 0));
	  strcat_s(st,suffix);
	  String^ ctrl_val = gcnew String(st);
	  ctrl->Text = ctrl_val;
}

//***********************************************
void InitializeGUI ()
{
single_acquire = false;
auto_acquire = false;
waiting_for_trigger = false;
vals_changed = true;

Setval(Adiv, a_vert,"V");

Setval(Bdiv, b_vert,"V");
Setval(Tdiv, horz,"s");
Setval(TrigV, trig_volts,"V");
Setval(SigGenF, sig_gen_freq,"Hz");
Setval(SigGenV, sig_gen_volts,"V");


SetA_Vertical->Value = 6;
SetB_Vertical->Value = 6;
SetHorizontal->Value = 9;
zedGraphControl1->GraphPane->YAxis->Scale->Min = -a_vert*v_divisions/2;
zedGraphControl1->GraphPane->YAxis->Scale->Max = a_vert*v_divisions/2 ;
zedGraphControl1->GraphPane->YAxis->Scale->MajorStep = a_vert;
zedGraphControl1->GraphPane->Y2Axis->Scale->Min = -b_vert*v_divisions/2;
zedGraphControl1->GraphPane->Y2Axis->Scale->Max = b_vert*v_divisions/2 ;
zedGraphControl1->GraphPane->Y2Axis->Scale->MajorStep = b_vert;
zedGraphControl1->GraphPane->XAxis->Scale->Min = -horz*v_divisions/2;
zedGraphControl1->GraphPane->XAxis->Scale->Max = horz*v_divisions/2 ;
zedGraphControl1->GraphPane->XAxis->Scale->MajorStep = horz;
Trig_A->Checked = true;
timer1->Enabled = true;
}


//*************************************************************************


//**************************************************************
// Build the Chart 
void CreateGraph( ZedGraphControl ^zgc ) 
{ 
   // get a reference to the GraphPane 
   GraphPane ^myPane = zgc->GraphPane; 
 
   // Set the Titles 
   myPane->Title->Text = "Simple Scope"; 
   myPane->XAxis->Title->Text = "Time (s)"; 
   myPane->YAxis->Title->Text = "A Volts"; 
   myPane->Y2Axis->Title->Text = "B Volts";

   // Make up some data arrays based on the Sine function 
   double x, y1, y2; 
   PointPairList ^list1 = gcnew PointPairList(); 
   PointPairList ^list2 = gcnew PointPairList(); 
   for ( int i = 0; i < 2; i++ ) 
   { 
      x = 0; 
	  y1 = 0; 
	  y2 = 0; 
      list1->Add( x, y1 ); 
      list2->Add( x, y2 ); 
   } 
 
   // Generate a red curve with diamond 
   // symbols, and "Porsche" in the legend 
   LineItem ^myCurve = myPane->AddCurve( "", 
	   list1, Color::Red, SymbolType::None ); 
 
   // Generate a blue curve with circle 
   // symbols, and "Piper" in the legend 
   myCurve = myPane->AddCurve( "", 
	   list2, Color::Blue, SymbolType::None ); 

	// Associate this curve with the Y2 axis
	myCurve->IsY2Axis = true;

	// Show the x axis grid
	myPane->XAxis->MajorTic->IsOpposite = false;
	myPane->XAxis->MinorTic->IsOpposite = false;
	myPane->XAxis->MajorGrid->IsVisible = true;


	// Make the Y axis scale red
	myPane->YAxis->Scale->FontSpec->FontColor = Color::Red;
	myPane->YAxis->Title->FontSpec->FontColor = Color::Red;
	// turn off the opposite tics so the Y tics don't show up on the Y2 axis
	myPane->YAxis->MajorTic->IsOpposite = false;
	myPane->YAxis->MinorTic->IsOpposite = false;
	// Don't display the Y zero line
	myPane->YAxis->MajorGrid->IsZeroLine = false;
	myPane->YAxis->MajorGrid->IsVisible = true;
	// Align the Y axis labels so they are flush to the axis
	myPane->YAxis->Scale->Align = AlignP::Inside;
	// Manually set the axis range
	myPane->YAxis->Scale->Min = -10;
	myPane->YAxis->Scale->Max = 10;


	// Enable the Y2 axis display
	myPane->Y2Axis->IsVisible = true;
	// Make the Y2 axis scale blue
	myPane->Y2Axis->Scale->FontSpec->FontColor = Color::Blue;
	myPane->Y2Axis->Title->FontSpec->FontColor = Color::Blue;
	// turn off the opposite tics so the Y2 tics don't show up on the Y axis
	myPane->Y2Axis->MajorTic->IsOpposite = false;
	myPane->Y2Axis->MinorTic->IsOpposite = false;
	// Display the Y2 axis grid lines
	myPane->Y2Axis->MajorGrid->IsVisible = false;
	// Align the Y2 axis labels so they are flush to the axis
	myPane->Y2Axis->Scale->Align = AlignP::Inside;
	myPane->Y2Axis->MajorGrid->IsZeroLine = false;



   // Tell ZedGraph to refigure the 
   // axes since the data have changed 
   zgc->AxisChange(); 
   zgc->Invalidate(); 
}

//--------------------------------------------------------------------------


	protected:
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		~Form1()
		{
			if (components)
			{
				delete components;
			}
		}
	private: System::Windows::Forms::Timer^  timer1;
private: System::Windows::Forms::Button^  TriggeredAcquire;

	private: System::Windows::Forms::Button^  single_trigger;
	private: System::Windows::Forms::TrackBar^  SetHorizontal;
	private: System::Windows::Forms::TrackBar^  Set_SigGen_Freq;
	private: System::Windows::Forms::TrackBar^  Set_SigGen_Volts;
	private: System::Windows::Forms::TrackBar^  SetA_Vertical;
	private: System::Windows::Forms::TrackBar^  SetB_Vertical;
	private: System::Windows::Forms::TrackBar^  Set_Trigger_Volts;
	private: System::Windows::Forms::RadioButton^  Trig_A;
	private: System::Windows::Forms::RadioButton^  Trig_B;
	private: System::Windows::Forms::Button^  QuitButton;
	private: System::Windows::Forms::Label^  label1;
	private: System::Windows::Forms::Label^  label2;
	private: System::Windows::Forms::Label^  label3;
	private: System::Windows::Forms::Label^  label4;
	private: System::Windows::Forms::Label^  label5;
	private: System::Windows::Forms::Label^  label6;
	private: System::Windows::Forms::Label^  Adiv;
	private: System::Windows::Forms::Label^  Bdiv;
	private: System::Windows::Forms::Label^  Tdiv;
	private: System::Windows::Forms::Label^  label7;
	private: System::Windows::Forms::Label^  TrigV;
	private: System::Windows::Forms::Label^  SigGenF;
	private: System::Windows::Forms::Label^  SigGenV;
	private: ZedGraph::ZedGraphControl^  zedGraphControl1;
private: System::Windows::Forms::PictureBox^  Trig_LED;








	protected: 
	private: System::ComponentModel::IContainer^  components;

	private:
		/// <summary>
		/// Required designer variable.
		/// </summary>


#pragma region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		void InitializeComponent(void)
		{
			this->components = (gcnew System::ComponentModel::Container());
			System::ComponentModel::ComponentResourceManager^  resources = (gcnew System::ComponentModel::ComponentResourceManager(Form1::typeid));
			this->timer1 = (gcnew System::Windows::Forms::Timer(this->components));
			this->TriggeredAcquire = (gcnew System::Windows::Forms::Button());
			this->single_trigger = (gcnew System::Windows::Forms::Button());
			this->SetHorizontal = (gcnew System::Windows::Forms::TrackBar());
			this->Set_SigGen_Freq = (gcnew System::Windows::Forms::TrackBar());
			this->Set_SigGen_Volts = (gcnew System::Windows::Forms::TrackBar());
			this->SetA_Vertical = (gcnew System::Windows::Forms::TrackBar());
			this->SetB_Vertical = (gcnew System::Windows::Forms::TrackBar());
			this->Set_Trigger_Volts = (gcnew System::Windows::Forms::TrackBar());
			this->Trig_A = (gcnew System::Windows::Forms::RadioButton());
			this->Trig_B = (gcnew System::Windows::Forms::RadioButton());
			this->QuitButton = (gcnew System::Windows::Forms::Button());
			this->label1 = (gcnew System::Windows::Forms::Label());
			this->label2 = (gcnew System::Windows::Forms::Label());
			this->label3 = (gcnew System::Windows::Forms::Label());
			this->label4 = (gcnew System::Windows::Forms::Label());
			this->label5 = (gcnew System::Windows::Forms::Label());
			this->label6 = (gcnew System::Windows::Forms::Label());
			this->Adiv = (gcnew System::Windows::Forms::Label());
			this->Bdiv = (gcnew System::Windows::Forms::Label());
			this->Tdiv = (gcnew System::Windows::Forms::Label());
			this->label7 = (gcnew System::Windows::Forms::Label());
			this->TrigV = (gcnew System::Windows::Forms::Label());
			this->SigGenF = (gcnew System::Windows::Forms::Label());
			this->SigGenV = (gcnew System::Windows::Forms::Label());
			this->zedGraphControl1 = (gcnew ZedGraph::ZedGraphControl());
			this->Trig_LED = (gcnew System::Windows::Forms::PictureBox());
			this->pictureBox1 = (gcnew System::Windows::Forms::PictureBox());
			this->label14 = (gcnew System::Windows::Forms::Label());
			this->label13 = (gcnew System::Windows::Forms::Label());
			this->label12 = (gcnew System::Windows::Forms::Label());
			this->label11 = (gcnew System::Windows::Forms::Label());
			this->label10 = (gcnew System::Windows::Forms::Label());
			this->label9 = (gcnew System::Windows::Forms::Label());
			this->label8 = (gcnew System::Windows::Forms::Label());
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->SetHorizontal))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->Set_SigGen_Freq))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->Set_SigGen_Volts))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->SetA_Vertical))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->SetB_Vertical))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->Set_Trigger_Volts))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->Trig_LED))->BeginInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->pictureBox1))->BeginInit();
			this->SuspendLayout();
			// 
			// timer1
			// 
			this->timer1->Interval = 60;
			this->timer1->Tick += gcnew System::EventHandler(this, &Form1::timer1_Tick);
			// 
			// TriggeredAcquire
			// 
			this->TriggeredAcquire->Location = System::Drawing::Point(554, 469);
			this->TriggeredAcquire->Name = L"TriggeredAcquire";
			this->TriggeredAcquire->Size = System::Drawing::Size(87, 27);
			this->TriggeredAcquire->TabIndex = 0;
			this->TriggeredAcquire->Text = L"Auto";
			this->TriggeredAcquire->UseVisualStyleBackColor = true;
			this->TriggeredAcquire->MouseClick += gcnew System::Windows::Forms::MouseEventHandler(this, &Form1::TriggeredAcquire_MouseClick);
			// 
			// single_trigger
			// 
			this->single_trigger->Location = System::Drawing::Point(490, 469);
			this->single_trigger->Name = L"single_trigger";
			this->single_trigger->Size = System::Drawing::Size(58, 27);
			this->single_trigger->TabIndex = 1;
			this->single_trigger->Text = L"Single";
			this->single_trigger->UseVisualStyleBackColor = true;
			this->single_trigger->Click += gcnew System::EventHandler(this, &Form1::single_trigger_Click);
			// 
			// SetHorizontal
			// 
			this->SetHorizontal->LargeChange = 1;
			this->SetHorizontal->Location = System::Drawing::Point(481, 239);
			this->SetHorizontal->Maximum = 23;
			this->SetHorizontal->Name = L"SetHorizontal";
			this->SetHorizontal->Size = System::Drawing::Size(184, 45);
			this->SetHorizontal->TabIndex = 2;
			this->SetHorizontal->Value = 15;
			this->SetHorizontal->ValueChanged += gcnew System::EventHandler(this, &Form1::SetHorizontal_ValueChanged);
			// 
			// Set_SigGen_Freq
			// 
			this->Set_SigGen_Freq->LargeChange = 1;
			this->Set_SigGen_Freq->Location = System::Drawing::Point(12, 39);
			this->Set_SigGen_Freq->Maximum = 20;
			this->Set_SigGen_Freq->Name = L"Set_SigGen_Freq";
			this->Set_SigGen_Freq->Size = System::Drawing::Size(184, 45);
			this->Set_SigGen_Freq->TabIndex = 3;
			this->Set_SigGen_Freq->Value = 9;
			this->Set_SigGen_Freq->ValueChanged += gcnew System::EventHandler(this, &Form1::Set_SigGen_Freq_ValueChanged);
			// 
			// Set_SigGen_Volts
			// 
			this->Set_SigGen_Volts->LargeChange = 1;
			this->Set_SigGen_Volts->Location = System::Drawing::Point(202, 39);
			this->Set_SigGen_Volts->Maximum = 40;
			this->Set_SigGen_Volts->Name = L"Set_SigGen_Volts";
			this->Set_SigGen_Volts->Size = System::Drawing::Size(184, 45);
			this->Set_SigGen_Volts->TabIndex = 4;
			this->Set_SigGen_Volts->Value = 5;
			this->Set_SigGen_Volts->ValueChanged += gcnew System::EventHandler(this, &Form1::Set_SigGen_Volts_ValueChanged);
			// 
			// SetA_Vertical
			// 
			this->SetA_Vertical->LargeChange = 1;
			this->SetA_Vertical->Location = System::Drawing::Point(514, 316);
			this->SetA_Vertical->Maximum = 8;
			this->SetA_Vertical->Name = L"SetA_Vertical";
			this->SetA_Vertical->Orientation = System::Windows::Forms::Orientation::Vertical;
			this->SetA_Vertical->Size = System::Drawing::Size(45, 120);
			this->SetA_Vertical->TabIndex = 5;
			this->SetA_Vertical->Value = 6;
			this->SetA_Vertical->ValueChanged += gcnew System::EventHandler(this, &Form1::SetA_Vertical_ValueChanged);
			// 
			// SetB_Vertical
			// 
			this->SetB_Vertical->LargeChange = 1;
			this->SetB_Vertical->Location = System::Drawing::Point(620, 316);
			this->SetB_Vertical->Maximum = 8;
			this->SetB_Vertical->Name = L"SetB_Vertical";
			this->SetB_Vertical->Orientation = System::Windows::Forms::Orientation::Vertical;
			this->SetB_Vertical->Size = System::Drawing::Size(45, 115);
			this->SetB_Vertical->TabIndex = 6;
			this->SetB_Vertical->Value = 6;
			this->SetB_Vertical->ValueChanged += gcnew System::EventHandler(this, &Form1::SetB_Vertical_ValueChanged);
			// 
			// Set_Trigger_Volts
			// 
			this->Set_Trigger_Volts->LargeChange = 1;
			this->Set_Trigger_Volts->Location = System::Drawing::Point(629, 57);
			this->Set_Trigger_Volts->Minimum = -10;
			this->Set_Trigger_Volts->Name = L"Set_Trigger_Volts";
			this->Set_Trigger_Volts->Orientation = System::Windows::Forms::Orientation::Vertical;
			this->Set_Trigger_Volts->Size = System::Drawing::Size(45, 114);
			this->Set_Trigger_Volts->TabIndex = 7;
			this->Set_Trigger_Volts->ValueChanged += gcnew System::EventHandler(this, &Form1::Set_Trigger_Volts_ValueChanged);
			// 
			// Trig_A
			// 
			this->Trig_A->AutoSize = true;
			this->Trig_A->Location = System::Drawing::Point(556, 142);
			this->Trig_A->Name = L"Trig_A";
			this->Trig_A->Size = System::Drawing::Size(60, 17);
			this->Trig_A->TabIndex = 8;
			this->Trig_A->TabStop = true;
			this->Trig_A->Text = L"Chan A";
			this->Trig_A->UseVisualStyleBackColor = true;
			this->Trig_A->CheckedChanged += gcnew System::EventHandler(this, &Form1::Trig_A_CheckedChanged);
			// 
			// Trig_B
			// 
			this->Trig_B->AutoSize = true;
			this->Trig_B->Location = System::Drawing::Point(556, 165);
			this->Trig_B->Name = L"Trig_B";
			this->Trig_B->Size = System::Drawing::Size(60, 17);
			this->Trig_B->TabIndex = 9;
			this->Trig_B->TabStop = true;
			this->Trig_B->Text = L"Chan B";
			this->Trig_B->UseVisualStyleBackColor = true;
			this->Trig_B->CheckedChanged += gcnew System::EventHandler(this, &Form1::Trig_B_CheckedChanged);
			// 
			// QuitButton
			// 
			this->QuitButton->Location = System::Drawing::Point(477, 145);
			this->QuitButton->Name = L"QuitButton";
			this->QuitButton->Size = System::Drawing::Size(50, 37);
			this->QuitButton->TabIndex = 10;
			this->QuitButton->Text = L"Quit";
			this->QuitButton->UseVisualStyleBackColor = true;
			this->QuitButton->Click += gcnew System::EventHandler(this, &Form1::QuitButton_Click);
			// 
			// label1
			// 
			this->label1->AutoSize = true;
			this->label1->Location = System::Drawing::Point(80, 29);
			this->label1->Name = L"label1";
			this->label1->Size = System::Drawing::Size(69, 13);
			this->label1->TabIndex = 11;
			this->label1->Text = L"Sig Gen Freq";
			// 
			// label2
			// 
			this->label2->AutoSize = true;
			this->label2->Location = System::Drawing::Point(287, 26);
			this->label2->Name = L"label2";
			this->label2->Size = System::Drawing::Size(71, 13);
			this->label2->TabIndex = 12;
			this->label2->Text = L"Sig Gen Volts";
			// 
			// label3
			// 
			this->label3->AutoSize = true;
			this->label3->Location = System::Drawing::Point(626, 44);
			this->label3->Name = L"label3";
			this->label3->Size = System::Drawing::Size(30, 13);
			this->label3->TabIndex = 13;
			this->label3->Text = L"Volts";
			// 
			// label4
			// 
			this->label4->AutoSize = true;
			this->label4->Location = System::Drawing::Point(498, 300);
			this->label4->Name = L"label4";
			this->label4->Size = System::Drawing::Size(61, 13);
			this->label4->TabIndex = 14;
			this->label4->Text = L"A Volts/Div";
			// 
			// label5
			// 
			this->label5->AutoSize = true;
			this->label5->Location = System::Drawing::Point(604, 300);
			this->label5->Name = L"label5";
			this->label5->Size = System::Drawing::Size(61, 13);
			this->label5->TabIndex = 15;
			this->label5->Text = L"B Volts/Div";
			// 
			// label6
			// 
			this->label6->AutoSize = true;
			this->label6->Location = System::Drawing::Point(554, 223);
			this->label6->Name = L"label6";
			this->label6->Size = System::Drawing::Size(51, 13);
			this->label6->TabIndex = 16;
			this->label6->Text = L"Time/Div";
			// 
			// Adiv
			// 
			this->Adiv->AutoSize = true;
			this->Adiv->Location = System::Drawing::Point(505, 439);
			this->Adiv->Name = L"Adiv";
			this->Adiv->Size = System::Drawing::Size(43, 13);
			this->Adiv->TabIndex = 17;
			this->Adiv->Text = L"500 mV";
			this->Adiv->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			// 
			// Bdiv
			// 
			this->Bdiv->AutoSize = true;
			this->Bdiv->Location = System::Drawing::Point(613, 434);
			this->Bdiv->Name = L"Bdiv";
			this->Bdiv->Size = System::Drawing::Size(43, 13);
			this->Bdiv->TabIndex = 18;
			this->Bdiv->Text = L"500 mV";
			this->Bdiv->TextAlign = System::Drawing::ContentAlignment::MiddleCenter;
			// 
			// Tdiv
			// 
			this->Tdiv->AutoSize = true;
			this->Tdiv->Location = System::Drawing::Point(554, 271);
			this->Tdiv->Name = L"Tdiv";
			this->Tdiv->Size = System::Drawing::Size(43, 13);
			this->Tdiv->TabIndex = 19;
			this->Tdiv->Text = L"500 mV";
			// 
			// label7
			// 
			this->label7->AutoSize = true;
			this->label7->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 12, System::Drawing::FontStyle::Bold, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->label7->Location = System::Drawing::Point(609, 16);
			this->label7->Name = L"label7";
			this->label7->Size = System::Drawing::Size(65, 20);
			this->label7->TabIndex = 20;
			this->label7->Text = L"Trigger";
			// 
			// TrigV
			// 
			this->TrigV->AutoSize = true;
			this->TrigV->Location = System::Drawing::Point(622, 167);
			this->TrigV->Name = L"TrigV";
			this->TrigV->Size = System::Drawing::Size(43, 13);
			this->TrigV->TabIndex = 21;
			this->TrigV->Text = L"500 mV";
			// 
			// SigGenF
			// 
			this->SigGenF->AutoSize = true;
			this->SigGenF->Location = System::Drawing::Point(93, 73);
			this->SigGenF->Name = L"SigGenF";
			this->SigGenF->Size = System::Drawing::Size(43, 13);
			this->SigGenF->TabIndex = 22;
			this->SigGenF->Text = L"500 mV";
			// 
			// SigGenV
			// 
			this->SigGenV->AutoSize = true;
			this->SigGenV->Location = System::Drawing::Point(303, 73);
			this->SigGenV->Name = L"SigGenV";
			this->SigGenV->Size = System::Drawing::Size(43, 13);
			this->SigGenV->TabIndex = 23;
			this->SigGenV->Text = L"500 mV";
			// 
			// zedGraphControl1
			// 
			this->zedGraphControl1->Location = System::Drawing::Point(7, 135);
			this->zedGraphControl1->Name = L"zedGraphControl1";
			this->zedGraphControl1->ScrollGrace = 0;
			this->zedGraphControl1->ScrollMaxX = 0;
			this->zedGraphControl1->ScrollMaxY = 0;
			this->zedGraphControl1->ScrollMaxY2 = 0;
			this->zedGraphControl1->ScrollMinX = 0;
			this->zedGraphControl1->ScrollMinY = 0;
			this->zedGraphControl1->ScrollMinY2 = 0;
			this->zedGraphControl1->Size = System::Drawing::Size(456, 361);
			this->zedGraphControl1->TabIndex = 24;
			// 
			// Trig_LED
			// 
			this->Trig_LED->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"Trig_LED.Image")));
			this->Trig_LED->Location = System::Drawing::Point(646, 469);
			this->Trig_LED->Name = L"Trig_LED";
			this->Trig_LED->Size = System::Drawing::Size(22, 24);
			this->Trig_LED->TabIndex = 25;
			this->Trig_LED->TabStop = false;
			this->Trig_LED->Visible = false;
			// 
			// pictureBox1
			// 
			this->pictureBox1->Image = (cli::safe_cast<System::Drawing::Image^  >(resources->GetObject(L"pictureBox1.Image")));
			this->pictureBox1->Location = System::Drawing::Point(646, 469);
			this->pictureBox1->Name = L"pictureBox1";
			this->pictureBox1->Size = System::Drawing::Size(22, 24);
			this->pictureBox1->TabIndex = 26;
			this->pictureBox1->TabStop = false;
			// 
			// label14
			// 
			this->label14->AutoSize = true;
			this->label14->Location = System::Drawing::Point(412, 110);
			this->label14->Name = L"label14";
			this->label14->Size = System::Drawing::Size(137, 13);
			this->label14->TabIndex = 59;
			this->label14->Text = L"arrow keys, or scroll wheel. ";
			// 
			// label13
			// 
			this->label13->AutoSize = true;
			this->label13->Location = System::Drawing::Point(412, 97);
			this->label13->Name = L"label13";
			this->label13->Size = System::Drawing::Size(135, 13);
			this->label13->TabIndex = 58;
			this->label13->Text = L"Adjust controls, with mouse";
			// 
			// label12
			// 
			this->label12->AutoSize = true;
			this->label12->Location = System::Drawing::Point(412, 84);
			this->label12->Name = L"label12";
			this->label12->Size = System::Drawing::Size(117, 13);
			this->label12->TabIndex = 57;
			this->label12->Text = L"Click on Single or Auto.";
			// 
			// label11
			// 
			this->label11->AutoSize = true;
			this->label11->Location = System::Drawing::Point(412, 71);
			this->label11->Name = L"label11";
			this->label11->Size = System::Drawing::Size(141, 13);
			this->label11->TabIndex = 56;
			this->label11->Text = L"Connect Sig Gen to Chan A.";
			// 
			// label10
			// 
			this->label10->AutoSize = true;
			this->label10->Location = System::Drawing::Point(412, 57);
			this->label10->Name = L"label10";
			this->label10->Size = System::Drawing::Size(145, 13);
			this->label10->TabIndex = 55;
			this->label10->Text = L"Cleverscope Acquisition Unit.";
			// 
			// label9
			// 
			this->label9->AutoSize = true;
			this->label9->Location = System::Drawing::Point(412, 44);
			this->label9->Name = L"label9";
			this->label9->Size = System::Drawing::Size(115, 13);
			this->label9->TabIndex = 54;
			this->label9->Text = L"Connect and power up";
			// 
			// label8
			// 
			this->label8->AutoSize = true;
			this->label8->Font = (gcnew System::Drawing::Font(L"Microsoft Sans Serif", 9.75F, System::Drawing::FontStyle::Regular, System::Drawing::GraphicsUnit::Point, 
				static_cast<System::Byte>(0)));
			this->label8->Location = System::Drawing::Point(412, 20);
			this->label8->Name = L"label8";
			this->label8->Size = System::Drawing::Size(165, 16);
			this->label8->TabIndex = 53;
			this->label8->Text = L"How to use Simple Scope:";
			// 
			// Form1
			// 
			this->AutoScaleDimensions = System::Drawing::SizeF(6, 13);
			this->AutoScaleMode = System::Windows::Forms::AutoScaleMode::Font;
			this->ClientSize = System::Drawing::Size(684, 521);
			this->Controls->Add(this->label14);
			this->Controls->Add(this->label13);
			this->Controls->Add(this->label12);
			this->Controls->Add(this->label11);
			this->Controls->Add(this->label10);
			this->Controls->Add(this->label9);
			this->Controls->Add(this->label8);
			this->Controls->Add(this->Trig_LED);
			this->Controls->Add(this->zedGraphControl1);
			this->Controls->Add(this->SigGenV);
			this->Controls->Add(this->SigGenF);
			this->Controls->Add(this->TrigV);
			this->Controls->Add(this->label7);
			this->Controls->Add(this->Tdiv);
			this->Controls->Add(this->Bdiv);
			this->Controls->Add(this->Adiv);
			this->Controls->Add(this->label6);
			this->Controls->Add(this->label5);
			this->Controls->Add(this->label4);
			this->Controls->Add(this->label3);
			this->Controls->Add(this->label2);
			this->Controls->Add(this->label1);
			this->Controls->Add(this->QuitButton);
			this->Controls->Add(this->Trig_B);
			this->Controls->Add(this->Trig_A);
			this->Controls->Add(this->Set_Trigger_Volts);
			this->Controls->Add(this->SetB_Vertical);
			this->Controls->Add(this->SetA_Vertical);
			this->Controls->Add(this->Set_SigGen_Volts);
			this->Controls->Add(this->Set_SigGen_Freq);
			this->Controls->Add(this->SetHorizontal);
			this->Controls->Add(this->single_trigger);
			this->Controls->Add(this->TriggeredAcquire);
			this->Controls->Add(this->pictureBox1);
			this->Name = L"Form1";
			this->Text = L"Simple Scope";
			this->Load += gcnew System::EventHandler(this, &Form1::Form1_Load);
			this->FormClosing += gcnew System::Windows::Forms::FormClosingEventHandler(this, &Form1::Form1_FormClosing);
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->SetHorizontal))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->Set_SigGen_Freq))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->Set_SigGen_Volts))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->SetA_Vertical))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->SetB_Vertical))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->Set_Trigger_Volts))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->Trig_LED))->EndInit();
			(cli::safe_cast<System::ComponentModel::ISupportInitialize^  >(this->pictureBox1))->EndInit();
			this->ResumeLayout(false);
			this->PerformLayout();

		}
#pragma endregion

	private: System::Void Form1_Load(System::Object^  sender, System::EventArgs^  e) 
	{
   int		nErr;
		 
				// Setup the graph 
   CreateGraph( zedGraphControl1 ); 
   nErr =scope_init ();
    if (nErr>0)
    	{
    	}
	else
		{
		InitializeGUI ();
		}
	}
//---------------------------------------------------------------------------------------
private: System::Void QuitButton_Click(System::Object^  sender, System::EventArgs^  e) 
		 {
		timer1->Enabled = false;
		scope_close ();
		exit(0);
		 }
//---------------------------------------------------------------------------------------
private: System::Void Form1_FormClosing(System::Object^  sender, System::Windows::Forms::FormClosingEventArgs^  e) 
		 {
		timer1->Enabled = false;
		scope_close ();
		 }
//---------------------------------------------------------------------------------------
private: System::Void SetA_Vertical_ValueChanged(System::Object^  sender, System::EventArgs^  e) 
		{
		a_vert =  v_div[SetA_Vertical->Value];
		Setval(Adiv, a_vert,"V");
		vals_changed = true;
		zedGraphControl1->GraphPane->YAxis->Scale->Min = -a_vert*v_divisions/2;
		zedGraphControl1->GraphPane->YAxis->Scale->Max = a_vert*v_divisions/2 ;
		zedGraphControl1->GraphPane->YAxis->Scale->MajorStep = a_vert;
		zedGraphControl1->GraphPane->AxisChange(); 
		zedGraphControl1->Invalidate(); 
		}
//---------------------------------------------------------------------------------------

private: System::Void SetB_Vertical_ValueChanged(System::Object^  sender, System::EventArgs^  e) 
		 {
		b_vert =  v_div[SetB_Vertical->Value];
		Setval(Bdiv, b_vert,"V");
		vals_changed = true;
		zedGraphControl1->GraphPane->Y2Axis->Scale->Min = -b_vert*v_divisions/2;
		zedGraphControl1->GraphPane->Y2Axis->Scale->Max = b_vert*v_divisions/2 ;
		zedGraphControl1->GraphPane->Y2Axis->Scale->MajorStep = b_vert;
		zedGraphControl1->GraphPane->AxisChange(); 
		zedGraphControl1->Invalidate(); 
		 }
//---------------------------------------------------------------------------------------

private: System::Void SetHorizontal_ValueChanged(System::Object^  sender, System::EventArgs^  e) 
		 {
		horz =  t_div[SetHorizontal->Value];
		Setval(Tdiv, horz,"sec");
		vals_changed = true;
		zedGraphControl1->GraphPane->XAxis->Scale->Min = -horz*t_divisions/2;
		zedGraphControl1->GraphPane->XAxis->Scale->Max = horz*t_divisions/2 ;
		zedGraphControl1->GraphPane->XAxis->Scale->MajorStep = horz;
		zedGraphControl1->GraphPane->AxisChange(); 
		zedGraphControl1->Invalidate();

		 }
//---------------------------------------------------------------------------------------

private: System::Void Set_SigGen_Freq_ValueChanged(System::Object^  sender, System::EventArgs^  e) 
		 {
		sig_gen_freq =  freqs[Set_SigGen_Freq-> Value];
		Setval(SigGenF, sig_gen_freq, "Hz");
		vals_changed = true;

		 }
//---------------------------------------------------------------------------------------

private: System::Void Set_SigGen_Volts_ValueChanged(System::Object^  sender, System::EventArgs^  e) 
		 {
		sig_gen_volts = Set_SigGen_Volts-> Value * 0.2;
		Setval(SigGenV, sig_gen_volts, "V");
		vals_changed = true;
		 }
//---------------------------------------------------------------------------------------

private: System::Void Set_Trigger_Volts_ValueChanged(System::Object^  sender, System::EventArgs^  e) 
		 {
		trig_volts = Set_Trigger_Volts-> Value * 0.2;
		Setval(TrigV, trig_volts, "V");
		vals_changed = true;

		 }
//---------------------------------------------------------------------------------------

private: System::Void Trig_A_CheckedChanged(System::Object^  sender, System::EventArgs^  e) 
		 {
		trig_channel = 0;
		vals_changed = true;

		 }
//---------------------------------------------------------------------------------------

private: System::Void Trig_B_CheckedChanged(System::Object^  sender, System::EventArgs^  e) 
		 {
		trig_channel = 1;
		vals_changed = true;
		 }
//---------------------------------------------------------------------------------------


private: System::Void single_trigger_Click(System::Object^  sender, System::EventArgs^  e) 
		 {
		vals_changed = true;
		Trig_LED->Visible = false;
		auto_acquire = false;
		waiting_for_trigger = false;
		TriggeredAcquire->Text="Auto";
		if (single_acquire)
			{
			single_acquire = false;
			single_trigger->Text="Single";
			trigger_action = acq_stop;   //stop doing stuff
			}
		else
			{
			single_acquire = true;
			single_trigger->Text="Wait..";
			trigger_action = acq_single;   //use triggered captured
			}

		 }
//---------------------------------------------------------------------------------------

private: System::Void TriggeredAcquire_MouseClick(System::Object^  sender, System::Windows::Forms::MouseEventArgs^  e) 
		 {
		vals_changed = true;
		single_acquire = false;
		Trig_LED->Visible = false;
		waiting_for_trigger = false;
		single_trigger->Text="Single";
		if (auto_acquire)
			{
			auto_acquire = false;
			TriggeredAcquire->Text="Auto";
			trigger_action = acq_stop;   //stop doing stuff
			}
		else
			{
			auto_acquire = true;
			TriggeredAcquire->Text="Triggering...";
			trigger_action = acq_auto;   //use auto captured
			}
		 }
//*****************************************************************************************
//This is the main event function. It checks to see if any values have changed, and if
//they have, it updates the acquire variable. 
//Next it sees if an acquisition is to be made - and if so, makes it.
//Next it checks if there are results - if so, get them
//Finally it checks if the changes that should have been updated by teh acquire (if it happened)
//have happened, and if not, it updates the acquisition unit itself. 

 private: System::Void timer1_Tick(System::Object^  sender, System::EventArgs^  e) 
 {
int	i;
double	xval;
int32	num_samples;
double	dT, T0;
float	a_waveform[max_samples];
float	b_waveform[max_samples];

if (vals_changed)	//here we put the latest set of updates in teh acquisition array
    {
	 update_values(a_vert, b_vert, horz, num_points,
	 sig_gen_freq,sig_gen_volts,trig_volts, trig_channel,trigger_action);
	 }
if ((!waiting_for_trigger) && (single_acquire || auto_acquire))
    {
    Trig_LED->Visible = false;

	waiting_for_trigger = true;
    vals_changed = false;		//will have been updated by acquire. We do it here so that if vals_changed
    scope_acquire ();       //is set true while acquiring, there 

	 }
if ((waiting_for_trigger) && check_for_samples())
	 {
	  Trig_LED->Visible = true;
	  waiting_for_trigger = false;
	  if (single_acquire) single_trigger->Text="Single";
	  single_acquire = false;
	  scope_read_waveform (a_waveform, b_waveform, &num_samples, &dT, &T0);
	  xval = T0 ;

	  IPointListEdit ^ip1 = (IPointListEdit^) zedGraphControl1->GraphPane->CurveList[0]->Points;  //           CurveList[L"Beta"]->Points;
	  IPointListEdit ^ip2 = (IPointListEdit^) zedGraphControl1->GraphPane->CurveList[1]->Points;  //           CurveList[L"Beta"]->Points;

	  if (( ip1 != nullptr ) && (ip2 != nullptr))
			{
			ip1->Clear();
			ip2->Clear();
			for (i=0; i < num_samples; i++)
				{
				ip1->Add( xval, a_waveform[i] );
				ip2->Add( xval, b_waveform[i] );
				xval = xval+dT;
				}
			}
	  zedGraphControl1->Invalidate();
	  }
if (vals_changed)
	  {					//vals have changed that couldn't be handled by teh acquire. 
	   update_values(a_vert, b_vert, horz, num_points,
		sig_gen_freq,sig_gen_volts,trig_volts, trig_channel,trigger_action);
	  scope_config();
	  vals_changed = false;		//updated if acquire did not update them
	  }

}
//---------------------------------------------------------------------------------------

};
}

