#define	max_samples 16384
#define	t_divisions	10
#define	v_divisions	8

//Trigger actions:
#define	acq_single	0
#define	acq_auto	1
#define	acq_stop	3

static double v_div[9] = { 0.01, 0.02, 0.05, 0.1, 0.2, 0.5, 1, 2, 5};
static	double t_div[25] = { 1,0.5,0.2,0.1,0.05,0.02,0.01,0.005,0.002,0.001,
					  500e-6,200e-6,100e-6, 50e-6,20e-6,10e-6,5e-6,2e-6,1e-6,
					  500e-9,200e-9,100e-9,50e-9,20e-9,10e-9};
static	double freqs[21] = {1.0,2,5,10,20,50,100,200,500,1000,2000,5000,10000,
					 20000,50000,100000,200000,500000,1000000,2000000,5000000};
static	float		a_samples[max_samples];	  	//contains the a channel samples
static	float		b_samples[max_samples];	  	//contains the b channel samples
static	uInt16		dig_samples[max_samples];	//contains teh digotal channel values


// = Sample Oscilloscope Include File ===================================== 
int32 call_cscope_control_driver(uInt16 command);
int32 scope_init (void);
int32 scope_close (void);
int32 scope_config (void); 
int32	scope_acquire (void);
int32 scope_read_waveform (float a_waveform[max_samples], float b_waveform[max_samples], int32 *num_samples,  double *delta_t, double *t_zero); 
int32 check_for_samples(void);
void update_values(double a_div, double b_div, double t_div, int32 number_of_points, 
					double freq, double sigvolts, double trigvolts, int32 trig_chan, uInt16 trigger_action);

char *eng(double value, int digits, int numeric);
